import hashlib
from functools import lru_cache

from odoo import release, http
from odoo.addons.saas_worker.const import ENV


def str2color(s):
    h = int(hashlib.sha1(s.encode('utf-8')).hexdigest(), 16)
    r = (h & 0xFF0000) >> 16
    g = (h & 0x00FF00) >> 8
    b = h & 0x0000FF
    return r, g, b


class TopBar(http.Controller):
    @http.route("/openerp_test/topbar.css", auth="none")
    def topbar(self, **kw):
        content = self._topbar()
        return http.request.make_response(content, headers=[('Content-Type', 'text/css')])

    @lru_cache(1)
    def _topbar(self):
        env = http.request.env
        copy_date = env['ir.config_parameter'].sudo().get_param('database.copy_date')
        r, g, b = str2color(ENV)
        values = {
            'server_version': release.version,
            'sv_bgcolor': '#%02X%02X%02X' % (255 - r, 255 - g, 255 - b),
            'sv_color': '#%02X%02X%02X' % (r, g, b),
            'copy_date': copy_date,
        }
        return env["ir.qweb"]._render("openerp_test.topbar", values)
